program Project1;

uses
  windows, messages, DirectDraw, ddutil;

{$R *.RES}

var
 Instance: HWnd;
 WindowClass: TWndClass;
 Handle: HWnd;
 msg: TMsg;
 FDirectDraw : IDirectDraw7;
 FPrimarySurface : IDirectDrawSurface7;
 FImageSurface : IDirectDrawSurface7;
 hRet : HRESULT;
 SurfaceDesc : TDDSurfaceDesc2;
 DC : HDC;
 bltfx : TDDBLTFX;


procedure DoExit;
begin
 FImageSurface:=nil;
 FPrimarySurface := nil;
 FDirectDraw := nil;
 Halt;
end;

function WindowProc (Hwn,msg,wpr,lpr: longint): longint; stdcall;
begin
 result:=defwindowproc(hwn,msg,wpr,lpr);
 if msg=wm_destroy then
  DoExit;

 if msg=wm_KeyDown then
  if wpr=VK_ESCAPE then
   DoExit;

 if msg=WM_PAINT then
  begin
   ZeroMemory(@bltfx, SizeOf(bltfx));
   bltfx.dwSize := sizeof(bltfx);
   bltfx.dwFillColor := 0;
   hRet := FPrimarySurface.Blt(nil, nil, nil, DDBLT_COLORFILL or DDBLT_WAIT, @bltfx);
   if hRet = DDERR_SURFACELOST then
    begin
     FPrimarySurface._Restore;
     FImageSurface._Restore;
     FPrimarySurface.Blt(nil, nil, nil, DDBLT_COLORFILL or DDBLT_WAIT, @bltfx);
     FImageSurface := DDLoadBitmap(FDirectDraw, '1.bmp', 0, 0);
    end;

   FPrimarySurface.BltFast (175, 75, FImageSurface, nil, DDBLTFAST_WAIT);
  end;
end;

begin
 FImageSurface:=nil;

 instance :=GetModuleHandle(nil);
 with WindowClass do
  begin
   style:=CS_HRedraw or CS_VRedraw;
   Lpfnwndproc:=@windowproc;
   Hinstance:=Instance;
   HbrBackground:= color_btnface;
   LpszClassName:='DX';
   Hcursor:=LoadCursor(0,IDC_ARROW);
  end;
 RegisterClass (WindowClass);

 Handle:=CreateWindowEx (0,'DX','',WS_POPUP, 5,5, GetSystemMetrics (SM_CXSCREEN), GetSystemMetrics (SM_CYSCREEN),0,0,instance, nil);
 UpdateWindow (Handle);

 hRet := DirectDrawCreateEx (nil, FDirectDraw, IDirectDraw7, nil);
 if hRet <> DD_OK then Halt;

 FDirectDraw.SetCooperativeLevel(Handle, DDSCL_FULLSCREEN or DDSCL_EXCLUSIVE);
 FDirectDraw.SetDisplayMode (800, 600, 16, 0, 0);

 FillChar (SurfaceDesc, SizeOf(SurfaceDesc), 0);
 SurfaceDesc.dwSize := SizeOf(SurfaceDesc);
 SurfaceDesc.dwFlags := DDSD_CAPS;
 SurfaceDesc.ddsCaps.dwCaps := DDSCAPS_PRIMARYSURFACE;
 FDirectDraw.CreateSurface(SurfaceDesc, FPrimarySurface, nil);

 FImageSurface := DDLoadBitmap(FDirectDraw, '1.bmp', 0, 0);

 while (GetMessage(msg, 0, 0, 0)) do
  begin
   translatemessage(msg);
   dispatchmessage (msg);
  end;
end.
